/*

The Net Usage Project
http://netusage.mozdev.org/

Copyright (C) 2006-2007, Loune Lam <lpgcritter at nasquan dot com>
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
Net Usage Item
ISP Definitions Version 3.0
{}
Australia

*/

var nu_isps_au = {
	'bigpond': {
		name: 'Bigpond',
		description: 'Please enter your Usage Allowance!',
		
		prefs: {
			'USERNAME': 'Username',
			'usage-quota': ['Usage Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
		},

		process: [
			// homepage
			'GET http://www.bigpond.com/default.asp',
			[/TS=([0-9]+)&TO=([0-9]+)&KID=([0-9]+)&MAC=([a-zA-Z0-9]+)/],

			// login
			//'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',
			'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',
			//'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttps%253A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%253FSUCCESS_PAGE%253Dhttps%253A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%253FFORM%253Dbigpond%2526AUTH_REDIR%253Dhttps%25253A%25252F%25252Fmy.bigpond.com%25252Fmybigpond%25252Fmyaccount%25252Fmyusage%25252Fdefault.do%2526TS%253D2006%2526TO%253D20%2526KID%253D1%2526MAC%253D%3B',
			//'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',
			'REFRESHREDIRECT',
			[
				/provided is either incorrect or incomplete/,
				'ERROR',
				/<b>(You entered an invalid username and password combination. <BR>Due to security precautions any account which has had three unsuccessful attempts to login will be locked out for three hours.)<\/b>/,
				'ERROR',
				/<title>LOG INTO BIGPOND/,
				'oldxml',
				/https:\/\/account\.bigpond\.com\/broadband\/usage\/secure\/monthlyusage\.do/,
				'oldpage',
				/\/mybigpond\/myaccount\/myusage\/default\.do/,
				'newpage',
			],
			
			// try old meter
			'LABEL oldpage',
			'USAGEPAGE',
			'GET https://account.bigpond.com/broadband/usage/secure/monthlyusage.do',
			[
				/Current Bill Period[^`]+?100%">([a-zA-Z0-9 ]+) to ([a-zA-Z0-9 ]+)[^`]+?Current Account Usage:[^`]+?<b>([0-9,\.]+)/,
				'logout',
				/UNABLE TO ACCESS USAGE INFORMATION/,
				'oldxml',
				/meter is no longer available at this location/, // go to new usage meter
				/<title>LOG INTO BIGPOND/,
				'oldxml',
			],
			// try new meter
			'LABEL newpage',
			'USAGEPAGE',
			'GET https://my.bigpond.com/mybigpond/myaccount/myusage/default.do',
			[ 
				/Current Plan:<\/td>[\s]+<td valign="top" nowrap="nowrap">([^<]+)[^`]+?Current Bill Period[^`]+?>([0-9a-zA-Z ]+) - ([0-9a-zA-Z ]+)[^`]+?Current Account Usage[^`]+?<strong>([0-9,\.]+)/,
				'logout',
			],
			// try old xml toolbar meter
			'LABEL oldxml',
			function(vars) { vars['TIMESTAMP'] = Math.round((new Date()).getTime()/1000); },
			'GETBASIC https://account.bigpond.com/siteminderagent/nocert/{TIMESTAMP}/smgetcred.scc?TYPE=16777217&REALM=$SM$Toolbar&TARGET=$SM$https%3a%2f%2faccount%2ebigpond%2ecom%2fbroadband%2fusage%2ftoolbar%2ftoolbar%2edo?version=1.4',
			[ 
				{
					'XPATHVERIFY': '/bigpond[@version="1.4"]/usage/account',
					'usage|MB': '/bigpond/usage/account/balance',
				},
				100
			],
			
			// logout
			'LABEL logout',
			'GET http://www.bigpond.com/mybigpond/logout.asp',
		],

		varsDisplay: {
			'2,0': {
				'NONE': '{2:1|startdate} {2:2|enddate}',
				'Usage': '{2:3|MB|usage} / {usage-quota}',
			},
			'3,0': {
				'NONE': '{3:1|planname} {3:2|startdate} {3:3|enddate}',
				'Usage': '{3:4|MB|usage} / {usage-quota}',
			},
			'4,0': {
				'Usage': '{usage} / {usage-quota}',
			},
		},

	},
	
	'netspace': {
		name: 'Netspace',
		process: [
			'GETBASIC https://usage.netspace.net.au/usage-meter/adslusage?version=2&granularity=MONTH',
			[
				// on/offpeak
				{
					'XPATHVERIFY': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]',
					'planname': '/USAGE/PLAN/@DESCRIPTION',
					
					'startdate': '/USAGE/@START_DATE',
					'enddate': '/USAGE/@END_DATE',

					'upload|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
					'download|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
					'download-quota|MB': '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',
					'uploadpo|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
					'downloadpo|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',
					'downloadpo-quota|MB': '/USAGE/PLAN/LIMIT[@NAME="Off Peak"]/@MEGABYTES',

					'free-upload|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
					'free-download|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
					'free-uploadpo|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
					'free-downloadpo|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',
				},
				// normal
				{
					'XPATHVERIFY': '/USAGE[@VERSION="2"]/TRAFFIC',
					'planname': '/USAGE/PLAN/@DESCRIPTION',

					'startdate': '/USAGE/@START_DATE',
					'enddate': '/USAGE/@END_DATE',

					//'upload': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
					//'download': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
					//'download-quota': '/USAGE/PLAN/LIMIT[@NAME="Standard"]/@MEGABYTES',
					'upload|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
					'download|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
					'download-quota|MB': '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',

					//'free-upload': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
					//'free-download': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
					'free-upload|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
					'free-download|MB': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
				},
				{
					'XPATHVERIFY': '/opt/@ERROR',
					'errortext': '/opt/@ERROR',
				},
				"ERROR",
			],
			'STARTUSAGEPAGE',
			'POST https://my.netspace.net.au/logincheck dest=%2Fusage-meter%2F&username={USERNAME}&password={PASSWORD}&Submit=Next',
		],

		varsDisplay: {
			'0,0': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Upload': ['{upload}', '{uploadpo}'],
				'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				'Free Upload': ['{free-upload}', '{free-uploadpo}'],
				'Free Download': ['{free-download}', '{free-downloadpo}'],
			},
			'0,1': {
				'Upload': '{upload}',
				'Download': '{download} / {download-quota}',
				'Free Upload': '{free-upload}',
				'Free Download': '{free-download}',
			},
		},
		
	},
		
	'tpgi': {
		name: 'TPG Internet',
		prefs: {
			'download-quota': ['Download Quota (MB)', PREF_TYPE_INT],
		},

		process: [
			'POST https://cyberstore.tpg.com.au/your_account/index.php check_username={USERNAME}&password={PASSWORD}&Submit=GO%21',
			[/Invalid username or customer ID or password/, "ERROR", /./],
			
			'USAGEPAGE',
			'GET https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage',
			[
				/<b>Package Type:<\/b> ([A-Za-z 0-9\.\+\/]+?([0-9]+)GB[A-Za-z 0-9\.\+\/]*)[^`]+?<b>Download Charges:<\/b> ([A-Za-z0-9 :]+)[^`]+?Expiry Date:<\/b> ([A-Za-z0-9 ]+)[^`]+?Charges: (\$[0-9\.]+)[^`]+?Download used: ([0-9\.]+) MB/,
				/<b>Package Type:<\/b> ([A-Za-z 0-9\.\+\/]+)[^`]+?<b>Download Charges:<\/b> ([A-Za-z0-9 :]+)[^`]+?Expiry Date:<\/b> ([A-Za-z0-9 ]+)[^`]+?Charges: (\$[0-9\.]+)[^`]+?Download used: ([0-9\.]+) MB/,
			],
			
			'GET https://cyberstore.tpg.com.au/your_account/index.php?function=logout',
		],

		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|planname} {1:4|enddate} {1:5|excesscharges} {1:3|alldownload}',
				'Download': '{1:6|MB|download} / {1:2|GB|download-quota}',
			},
			'1,1': {
				'NONE': '{1:1|planname} {1:3|enddate} {1:4|excesscharges} {1:2|alldownload}',
				'Download': '{1:5|MB|download} / {download-quota}',
			}
		},
	},

	'iinet': {
		name: 'iiNet broadband',
		process: [
			// preprocess, chop off @iinet
			function(vars) {
				var u = vars['USERNAME'].split(/@/);
				if (u.length > 1 && u[1].substr(0, 6) == 'iinet.')
					vars['USERNAME'] = u[0];
			},
			'USAGEPAGE',
			'POST https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi action=login&username={USERNAME}&password={PASSWORD}',
			[
				/([0-9]+) MB Peak time, ([0-9]+) MB[^`]+?On since (.+?) on IP ([^<]+)[^`]+?Bliinkzone[^`]+?Bliinktime[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
				/([0-9]+) MB Peak time, ([0-9]+) MB[^`]+?On since (.+?) on IP ([^<]+)[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
				/([0-9]+) MB[^`]+?On since (.+?) on IP ([^<]+)[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
				/([0-9]+) MB[^`]+?On since (.+?) on IP ([^<]+)[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
				/Enter your username and password/, "ERROR"
			],
		],
		
		varsDisplay: {
			'0,0': { // old bliink
				'NONE': '{0:5|startdate} {0:6|enddate}',
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'On since': '{0:3}',
				'IP': '{0:4}',
				'Download': ['{0:7|MB|download} / {0:1|MB|download-quota}', '{0:9|MB|downloadpo} / {0:2|MB|downloadpo-quota}'],
				'Free (Bliinkzone)': ['{0:8|MB|free-usage}', ''],
			},
			'0,1': { // new ii2
				'NONE': '{0:5|startdate} {0:6|enddate}',
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'On since': '{0:3}',
				'IP': '{0:4}',
				'Download': ['{0:7|MB|download} / {0:1|MB|download-quota}', '{0:8|MB|downloadpo} / {0:2|MB|downloadpo-quota}'],
				'Free': ['{0:9|MB|free-usage}', ''],
			},
			'0,2': { // new ii2 biz (no offpeak)
				'NONE': '{0:4|startdate} {0:5|enddate}',
				'On since': '{0:3}',
				'IP': '{0:4}',
				'Download total': '{0:9|MB|usage} / {0:1|MB|usage-quota}',
				'Download (Peak)': '{0:6|MB|download}',
				'Download (Offpeak)': '{0:7|MB|downloadpo}',
				'Free': '{0:8|MB|free-usage}',
			},
			'0,3': { // new ii2 no offpeak
				'NONE': '{0:4|startdate} {0:5|enddate}',
				'On since': '{0:3}',
				'IP': '{0:4}',
				'Download': '{0:6|MB|download} / {0:1|MB|download-quota}',
				'Free': '{0:7|MB|free-usage}',
			},
		},
	},

	'internode': {
		name: 'Internode',
		process: [
			'POST https://accounts.internode.on.net/cgi-bin/padsl-usage username={USERNAME}&password={PASSWORD}',
			[ 
				/([0-9\.]+) ([0-9]+) ([0-9\/]+)/,
				/([^\r\n]+)/, "ERROR",
			],
			'STARTUSAGEPAGE',
			'POST https://accounts.internode.on.net/cgi-bin/login username={USERNAME}&password={PASSWORD}&access=Personal_ADSL',
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:3|rolldate}',
				'Download': '{0:1|MB|download} / {0:2|MB|download-quota}',
			}
		},

	},
		
	'optus': {
		name: 'OptusNet',
		process: [
			'POST https://memberservices.optuszoo.com.au/myusage/usage.txt login={USERNAME}&passwd={PASSWORD}',
			[ 
				/end=([0-9\-]+)[^`]+?last=([0-9:\- ]+)[^`]+?offpeak_usage=([0-9]+)MB[^`]+?plan_limit=([0-9]+)MB[^`]+?plan_name=([^\r\n]+)[^`]+?plan_offpeak=([0-9]+)MB[^`]+?start=([0-9\-]+)[^`]+?usage=([0-9]+)MB/,
				/error=1[^`]+?reason=([^\r\n]+)/, "ERROR"
			],
			'STARTUSAGEPAGE',
			'POST https://memberservices.optuszoo.com.au/login/?target=/myusage/ Action=login&username={USERNAME}&password={PASSWORD}',
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:5|planname} {0:7|startdate} {0:1|enddate}',
				'COLUMNHEADING': ['Peak', 'Offpeak'],
				'Last Update': ['{0:2}', ''],
				'Download': ['{0:8|MB|download} / {0:4|MB|download-quota}', '{0:3|MB|downloadpo} / {0:6|MB|downloadpo-quota}'],
			}
		},

	},
	
	'adam': {
		name: 'Adam Internet',
		process: [
			'GETBASIC http://members.adam.com.au/um1.2/',
			[ 
				{
					'XPATHVERIFY': '/response/UsageMeter/Version',
					'upload|MB': '/response/Account/SubAccount/MegabytesUploadedTotal',
					'download|MB': '/response/Account/SubAccount/MegabytesDownloadedExternal',
					'download-quota|MB': '/response/Account/MegabyteQuota',
					'downloadpo|MB': '/response/Account/SubAccount/MegabytesDownloadedTotal - /response/Account/SubAccount/MegabytesDownloadedExternal',
					'downloadpo-quota|MB': '/response/Account/MegabyteQuota',
					'startdate': '/response/Account/QuotaStartDate',
					
					'recorded': '/response/Account/SubAccount/LastUpdate',
				},
			],
			'STARTUSAGEPAGE',
			'POST http://members.adam.com.au/index.php Username={USERNAME}&Password={PASSWORD}&Login=Log+In',
		],
		
		varsDisplay: {
			'0,0': {
				'COLUMNHEADING': ['External', 'Internal'],
				'Last update': ['{recorded}', ''],
				'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				'Upload': ['{upload}', ''],
			}
		},
	},
		
	'chariot': {
		name: 'Chariot',
		prefs: {
			'USERNAME': 'Email',
			'ssfstate': ['State', PREF_TYPE_STRING | PREF_FLAG_GENERAL | PREF_FLAG_REQUIRED,
				{ 'NSW': '2', 
				 'QLD': '1',
				 'VIC': '3',
				 'SA': '4',
				 'TAS': '5',
				 'NT': '6',
				 'WA': '7', },
				],
		},

		process: [
			'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi action=login&SearchServerFirst={ssfstate}&u={USERNAME}&p={PASSWORD}&SrchSrvrFrst={ssfstate}&submit=Enter+Account+Tools',
			[
				/Username not found/, "ERROR",
				/<span style="color:#ff0000">([^<]+)/, "ERROR",
				/<input type="hidden" name="sId" value="([^"]*)" \/><input type="hidden" name="cerb" value="([^"]*)" \/><input type="hidden" name="thistime" value="([^"]*)" \/><input type="hidden" name="action" value=""><input type="hidden" name="rawval" value="([^"]*)"><input type="hidden" name="popWnd" value="([^"]*)">[^`]+?<br>([\-0-9]+) \/ ([0-9]+)kb \([^`]+?<br>([\-0-9]+) \/ ([0-9]+)kb \(/,
			],
			
			'USAGEPAGE',
			'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi sId={0:1}&cerb={0:2}&thistime={0:3}&action=Account+Usage&rawval={0:4}&popWnd={0:5}',
			[ 
				// /<\/table>[\s]+<br>([0-9]+) \/ ([0-9]+) mb[^`]+?<td align=center valign=bottom><font size=1 face=arial><b>([0-9]+)[^`]+?Last&nbsp;Update:&nbsp;([0-9\/ :]+)&nbsp; &nbsp; &nbsp;[\s]+Total&nbsp;Downloaded:&nbsp;([0-9\.]+)[^`]+?Last&nbsp;Update:&nbsp;([0-9\/ :]+)&nbsp; &nbsp; &nbsp;[\s]+Total&nbsp;Uploaded:&nbsp;([0-9\.]+)/,
				/<\/table>[\s]+<br>([0-9]+) \/ ([0-9]+) mb[^`]+?/
			],

			'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi sId={0:1}&cerb={0:2}&thistime={0:3}&action=Account+Status&rawval={0:4}&popWnd={0:5}',
			[ 
				/Plan type[\s]+<\/td><td>[\s]+([^\n\r]+)[^`]+?Next due date[\s]+<\/td><td>[\s]+([0-9\\/]+)/
			],

			'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi sId={0:1}&cerb={0:2}&thistime={0:3}&action=Logout&rawval={0:4}&popWnd={0:5}',
		],

		varsDisplay: {
			'1,0': {
				'NONE': '{2:1|planname} {2:2|rolldate}',
				'Download': '{1:1|MB|download} / {1:2|MB|download-quota}',
				'Email space used': '{0:6} / {0:7}',
				'Web space used': '{0:8} / {0:9}',
			}
		},
	},
		
	'westnet': {
		name: 'Westnet',
		process: [
			'POST https://secure1.wn.com.au/webservices/customer/ADSLUsage/adslxmlusage.asmx/getUsage username={USERNAME}&password={PASSWORD}',
			[
				/xmlns:xsi="http:\/\/www.w3.org\/2001\/XMLSchema-instance" xsi:nil="true"/,
				"ERROR",
				/<usagelimit>([0-9]+) \/ ([0-9]+)<\/usagelimit>[^`]*<peakused>([0-9\.,]+)<\/peakused>[^`]*<peakfree>([0-9\.,]+)<\/peakfree>[^`]*<offpeakused>([0-9\.,]+)<\/offpeakused>[^`]*<offpeakfree>([0-9\.,]+)<\/offpeakfree>/,
				/<usagelimit>([0-9]+)<\/usagelimit>[^`]*<peakused>([0-9\.,]+)<\/peakused>[^`]*<peakfree>([0-9\.,]+)<\/peakfree>/,
			],
			'STARTUSAGEPAGE',
			'POST https://myaccount.westnet.com.au/Login.aspx?ReturnUrl=%2fTechnical%2fUsage%2fDefault.aspx tbUsername={USERNAME}&tbPassword={PASSWORD}',
		],

		varsDisplay: {
			'0,1': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Download': ['{0:3|MB|download} / {0:1|MB|download-quota}', '{0:5|MB|downloadpo} / {0:2|MB|downloadpo-quota}'],
				'Free Download': ['{0:4|MB|free-usage}', '{0:6|MB|free-usagepo}'],
			},
			'0,2': {
				'Download': '{0:2|MB|download} / {0:1|MB|download-quota}',
				'Free Download': '{0:3|MB|free-usage}',
			},
		},
	},

		
	'unwired': {
		name: 'Unwired',
		process: [
			'POST https://www.unwired.com.au/myaccount/login.php?ev=nx login_name={USERNAME}&login_password={PASSWORD}&loginbutton=Login',
			[/Login failed/, "ERROR", /./],
			
			'USAGEPAGE',
			'GET https://www.unwired.com.au/myaccount/usage.php',
			[ 
				/My current plan is: ([A-Za-z0-9 \/]+)[^`]+?My current usage allowance: ([0-9]+)[^`]+?usage.php">([A-Za-z0-9\-]+) - ([A-Za-z0-9\-]+)[^`]+?Total<\/td>[\r\n 	]+<td>([0-9\.]+)<\/td>[\r\n 	]+<td>([0-9\.]+)/,
			],
			
			'GET https://www.unwired.com.au/myaccount/logout.php',
		],
		
		strToInt: function (s) {
			var i = parseInt(s, 10);
			return (i < 300) ? i*1000 : i;
		},

		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|planname} {1:3|startdate} {1:4|enddate} {1:5|MB|upload}',
				'Download': '{1:6|MB|download} / {1:2|strToInt|download-quota}',
			}
		},
	},
		
		
	'aanet': {
		name: 'aaNet ADSL',
		prefs: {
			'USERNAME': 'ADSL Phone Number',
			'download-quota': ['Download Quota (MB) (Optional)', PREF_TYPE_INT]
		},

		process: [
			'GET https://www.aanet.com.au/usage3.php?{USERNAME},{PASSWORD}',
			[ 
				/([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+),([0-9]+),([^,]+),([^,\r\n]+)/,
				/Login Failed/, "ERROR",
			],
			
			'MAPVARS',

			function(vars) { // aaNet usage is max of downloads or uploads
				vars['usage'] = Math.max(parseInt(vars['download'],10), parseInt(vars['upload'],10));
			},
			'STARTUSAGEPAGE',
			'POST https://www.aanet.com.au/members/checkuser.php servicenumber={USERNAME}&password={PASSWORD}',
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:7|planname} {0:4|rolldate}',
				'Last Updated': '{0:3}',
				'Upload': '{0:1|B|upload} / {download-quota}',
				'Download': '{0:2|B|download} / {0:5|MiB|download-quota}',
			}
		},

	},
		
	'exetel': {
		name: 'Exetel',
		description: 'Please enter your usage quota and start day below.',
		
		prefs: {
			'typeurl': ['Service', PREF_TYPE_STRING | PREF_FLAG_GENERAL | PREF_FLAG_REQUIRED,
				{ 'ADSL': 'members',
				 'Wireless': 'wireless_login' }
				],
			'rolldate': ['Start Day of Month', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			'download-quota': ['Peak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			'downloadpo-quota': ['Offpeak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
		},

		process: [
			'GET https://www.exetel.com.au/{typeurl|NOESC}/',

			'POST https://www.exetel.com.au/{typeurl|NOESC}/ login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',
			[
				/The Service Number and Password you have entered is invalid/, "ERROR",
				/./
			],
			
			'USAGEPAGE',
			'GET https://www.exetel.com.au/{typeurl|NOESC}/usage_monthly_query.php',
			[
				/Total:[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>/
			],
			
			'GET https://www.exetel.com.au/{typeurl|NOESC}/logout.php',
		],
		
		varsDisplay: {
			'1,0': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Upload': ['{1:3|MB|upload}', '{1:1|MB|uploadpo}'],
				'Download': ['{1:4|MB|download} / {download-quota}', '{1:2|MB|downloadpo} / {downloadpo-quota}'],
			}
		},
	},
		
		
	'onthenet': {
		name: 'OntheNet',
		vars: {
			'basicrealm': 'Unauthorised Access Prohibited',
		},
		process: [
			'GETBASIC http://dslstats.onthenet.com.au/{USERNAME}/',
			
			'USAGEPAGE',
			'GETBASIC http://dslstats.onthenet.com.au/services/usageCurrent/{USERNAME}',
			[ 
				/Plan -<\/b> ([A-Za-z0-9 \-\/]+)[^`]+?nowrap>[\s]+([0-9\-]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>([0-9]+)[^`]+?nowrap>([0-9]+)/,
			],
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:1|planname} {0:2|startdate}',
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Download': ['{0:4|MB|download} / {0:3|MB|download-quota}', '{0:6|MB|downloadpo} / {0:5|MB|downloadpo-quota}'],
				'Upload': ['{0:8|MB|upload}', ''],
			}
		},

	},
		
	'netcall': {
		name: '.Netcall',
		process: [
			'GET https://www.netcall.com.au/usage2.php?{USERNAME},{PASSWORD}',
			[ 
				/([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+),([0-9]+),([^,]+),([^,]+)/,
				/([^\r\n]+)/, "ERROR",
			],
			'STARTUSAGEPAGE',
			'POST https://www.netcall.com.au/members.html servicenumber={USERNAME}&password={PASSWORD}',
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:7|planname} {0:4|rolldate} {0:1|B|upload}',
				'Recorded': '{0:3}',
				'Download': '{0:2|B|download} / {0:5|MB|download-quota}',
			}
		},

	},

	'westvic': {
		name: 'Westvic Broadband',
		description: 'Please enter your Download Allowance',
		
		prefs: {
			'download-quota': ['Download quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			'downloadpo-quota': ['Off-peak Download quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
		},

		process: [
			function(vars) { if (!vars['USERNAME'].match(/.*\@westvic$/)) vars['USERNAME'] = vars['USERNAME']+"@westvic"; },
			'USAGEPAGE',
			'POST http://accounts.westvic.com.au/LOGIN credential_0={USERNAME}&credential_1={PASSWORD}&submit=Login&destination=%2F',
			[ 
				/type="password" class="login" id="secretkey"/, "ERROR",
				/<b>Total<\/b><\/font>[^`]+?<b>([0-9\.]+) MB[^`]+?<b>([0-9\.]+) MB[^`]+?<b>Total<\/b><\/font>[^`]+?<b>([0-9\.]+) MB[^`]+?<b>([0-9\.]+) MB/,
			],
		],

		varsDisplay: {
			'0,1': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Upload': ['{0:1|MB|upload}', '{0:3|MB|uploadpo}'],
				'Download': ['{0:2|MB|download} / {download-quota}', '{0:4|MB|downloadpo} / {downloadpo-quota}'],
			}
		},

	},
		

	'gnode': {
		name: 'G-Node',

		process: [
			'GET https://www.g-node.com.au/netusage.asp?username={USERNAME}&password={PASSWORD}',
			[
				{
					'XPATHVERIFY': '/gnode/netusage/plan',
					'planname': '/gnode/netusage/plan',
					'speed': '/gnode/netusage/speed',
					'monthyear': '/gnode/netusage/date',
					
					'upload|MB': '/gnode/netusage/upload_total',
					'download-quota|MB': '/gnode/netusage/download_quota',
					'download-total|MB': '/gnode/netusage/download_total',
					'download|MB': '/gnode/netusage/download_peak',
					'downloadpo|usagepo|MB': '/gnode/netusage/download_total - /gnode/netusage/download_peak',
				},
				{
					'XPATHVERIFY': '/gnode/netusage/error',
					'errortext': '/gnode/netusage/error',
				},
			],
			'MAPVARS',
			function(vars) {
				if (vars['speed'] == '8192/384') { // 8192/384 plans have off peak quota
					vars['usagepo-quota'] = vars['downloadpo-quota'] = vars['download-quota'];
					vars['parse0'] = 5;
				}
				if (vars['downloadpo'] == 0) { // these plans have no off peak
					vars['parse0'] = 4;
				}
			},
			
			'STARTUSAGEPAGE',
			'POST https://www.g-node.com.au/login.asp username={USERNAME}&password={PASSWORD}&Login=Login',
			[/Incorrect username or password/, "ERROR", /./],
			'GET https://www.g-node.com.au/services.asp',
		],

		varsDisplay: {
			// free gtime accounting
			'0,0': {
				'Download': '{download} / {download-quota}',
				'G-Time Download': '{downloadpo}',
				'Upload': '{upload}',
			},
			// no g time accounting
			'0,4': {
				'Download': '{download} / {download-quota}',
				'Upload': '{upload}',
			},

			// off peak accounting
			'0,5': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				'Upload': '{upload}',
			},
		},
	},
		
		
	'kern': {
		name: 'Kern Internet',
		vars: {
			'basicrealm': 'Kern Internet custdata',
		},
		process: [
			'USAGEPAGE',
			'GETBASIC http://mozart.kern.com.au/custdata/time-block-list.php3',
			/<TD CLASS=cols1>([0-9A-Za-z ]+) - ([0-9A-Za-z ]+)<\/TD>[\s]+<TD CLASS=cols0>([A-Za-z0-9\/ \+\-]+)[^`]+?([0-9]{2,})&[^`]+?<TD CLASS=cols0>([0-9:]+)<BR>([0-9\.]+)MB/,
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:3|planname} {0:1|startdate} {0:2|enddate}',
				'Downloads': '{0:6|MB|download} / {0:4|MB|download-quota}',
				'Time used': '{0:5|MB|timeused}',
			},
		},
	},
		
	
	'comcen': {
		name: 'ComCen Internet',
		prefs: {
			'USERNAME': 'DSL Number',
			'download-quota': ['Download quota (MB)', PREF_TYPE_INT],
		},

		process: [
			'POST http://star.comcen.com.au/cgi-bin/user-services.cgi username={USERNAME}&password={PASSWORD}',
			[/Login failed please retry/, "ERROR", /./],
			
			'USAGEPAGE',
			'GET http://star.comcen.com.au/cgi-bin/dslusage.cgi?displayunit=MB',
			[
				/Billing Period:<\/b><\/font><\/td><td><font size="1">([0-9 A-Za-z]+) - ([0-9 A-Za-z]+)[^`]+?([0-9]+) MB Peak \/ ([0-9]+) MB Offpeak[^`]+?([0-9\.]+)<\/td><td[^>]*>([0-9\.]+)<\/td><td[^>]*>([0-9\.]+)<\/td><td[^>]*>([0-9\.]+)<\/td><\/tr>[\r\n]{1}/,
				/Billing Period:<\/b><\/font><\/td><td><font size="1">([0-9 A-Za-z]+) - ([0-9 A-Za-z]+)[^`]+?<td[^>]*>([0-9\.]+)<\/td><td[^>]*>([0-9\.]+)<\/td><td[^>]*>([0-9\.]+)<\/td><\/tr>[\r\n]{1}/,
			],
			
			'GET http://star.comcen.com.au/cgi-bin/user-services.cgi?logout=1',
		],

		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|startdate} {1:2|enddate} {1:6|MB|upload} {1:8|MB|uploadpo}', // 1:6 1:8 are weird small num
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Download': ['{1:5|MB|download} / {1:3|MB|download-quota}', '{1:7|MB|downloadpo} / {1:4|MB|downloadpo-quota}'],
			},
			'1,1': {
				'NONE': '{1:1|startdate} {1:2|enddate} {1:4|MB|upload}', // 1:4 wierd small num; 1:5 total
				'Download': '{1:3|MB|download} / {download-quota}',
			},
		},
	},

	'wideband': {
		name: 'Wideband Networks',
		process: [
			'POST https://my.wideband.net.au/ destination=%2F&login_username={USERNAME}&login_password={PASSWORD}',
			[/Username or password was incorrect/, "ERROR", /./],
			
			'USAGEPAGE',
			'GET https://my.wideband.net.au/usage.php',
			/Total Used<\/strong>[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?Last updated: ([^<]+)/,
			
			function (vars) {
				vars['1:5'] = parseInt(vars['1:5'], 10) + parseInt(vars['1:2'], 10); // peak quota
				vars['1:6'] = parseInt(vars['1:6'], 10) + parseInt(vars['1:4'], 10); // offpeak quota
			},
			'GET https://my.wideband.net.au/logout.php',
		],

		varsDisplay: {
			'1,0': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Upload': ['{1:1|MB|upload}', '{1:3|MB|uploadpo}'],
				'Download': ['{1:2|MB|download} / {1:5|MB|download-quota}', '{1:4|MB|downloadpo} / {1:6|MB|downloadpo-quota}'],
				'Last updated': ['{1:7|recorded}', ''],
			},
		},
	},

/*
	'peopletelecom': {
		name: 'People Telecom',
		description: 'Please enter your download quota.',
		
		prefs: {
			'download-quota': ['Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
		},

		process: [
			'POST https://www.peopleservice.com.au/login.php jclerk_id={USERNAME}&passwd={PASSWORD}',
			[/<span class="accountname"><\/span>/, "ERROR", /./],
			
			'GET https://www.peopleservice.com.au/login.php?login2=Y&jclerk_id={USERNAME}',
			
			'USAGEPAGE',
			'GET http://www.peopleservice.com.au/sdocs.php?swiftservicetrafficaccountingselectservice=Y',
			[ 
				/<font color="#d70079">\[([0-9\/]+)[^`]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+/,
			],
			
			'GET http://www.peopleservice.com.au/login.php?logout=Y',
		],

		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|startdate}',
				'Download': '{1:2|MB|download} / {download-quota}',
				'Peering': '{1:3|MB|free-download}',
				'Internal': '{1:4|MB|downloadpo}',
			}
		},
	}, */
		
	'clearnetworks': {
		name: 'Clear Networks',
		process: [
			'POST https://www.clearnetworks.com.au/myaccount.html accNumber={USERNAME}&accPassword={PASSWORD}&sessionID=&B1=Login',
			[
				/Authorisation Failed/, "ERROR",
				/sessionID" value="([^"]+)[^`]+?accNumber" value="([^"]+)/
			],
			
			'USAGEPAGE',
			'POST https://www.clearnetworks.com.au/myaccount.html sessionID={1:1}&accNumber={1:2}&accOption=Check+Usage&sessionID={1:1}&accNumber={1:2}&CurrentPass=&NewPass=&NewPassVerify=',
			[ 
				/Current Plan:<\/b><\/td><td>([^<]+)<\/td><\/tr>[^`]+?<tr><td><b>Data Included:<\/b><\/td><td>([0-9]+) GB<\/td><\/tr>[\s]+<tr><td><b>Last Update:<\/b><\/td><td><font color=red>([^<]+)[^`]+?Data usage this period:<\/td><td>&nbsp;([0-9\.]+)/,
			],
		],

		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|planname}',
				'Last Update': '{1:3}',
				'Download': '{1:4|MB|download} / {1:2|GB|download-quota}',
			}
		},
	
	},
	
	'velocitynet': {
		name: 'Velocity Internet',
		prefs: {
			'download-quota': ['Peak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			'downloadpo-quota': ['Off-peak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
		},

		process: [
			'POST https://toolbox.velocitynet.com.au/login_test.cfm login={USERNAME}&domain=velocitynet.com.au&pwd={PASSWORD}&x=60&y=9',
			[/You have entered an Incorrect Username\/Password combination/, "ERROR", /./],
			
			'USAGEPAGE',
			'GET https://toolbox.velocitynet.com.au/usage.cfm',
			[ 
				/display=detail&showtype=detail">([A-Za-z0-9 ]+)[^`]+?<td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>[^`]+?<td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>/,
			],
		],

		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|startdate}',
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Download': ['{1:3|MB|download} / {download-quota}', '{1:5|MB|downloadpo} / {downloadpo-quota}'],
				'Free': ['{1:2|MB|free-download}', '{1:4|MB|free-downloadpo}'],
			},
		},
	
	},
	

	'amnet': {
		name: 'Amnet',

		process: [
			'GET http://memberutils.amnet.com.au/ClientLogin.aspx',
			/id="__VIEWSTATE" value="([^"]+)"/,

			'POST http://memberutils.amnet.com.au/ClientLogin.aspx __EVENTTARGET=&__EVENTARGUMENT=&__VIEWSTATE={0:1}&ctl00%24MemberToolsContent%24txtUsername={USERNAME}&ctl00%24MemberToolsContent%24txtPassword={PASSWORD}&ctl00%24MemberToolsContent%24btnLogin=Login',
			[ /Your username\/password was incorrect/, "ERROR", /./ ],
			
			'USAGEPAGE',
			'GET http://memberutils.amnet.com.au/UsageDetails.aspx',
			/_planname">([^<]+)<(?:.|\r|\n)*_basicusage">(\d+)<(?:.|\r|\n)*_peeringusage">(\d+)<(?:.|\r|\n)*selected="selected" value="[^"]+">[A-Za-z0-9]+, ([^<]+)<(?:.|\r|\n)*Total usage:(?:<[^>]+>|\s+)+(\d+\.\d+) GB(?:<[^>]+>|\s+)+(\d+\.\d+) GB(?:<[^>]+>|\s+)+(\d+\.\d+) GB(?:<[^>]+>|\s+)+(\d+\.\d+) GB/,
			
			'GET http://memberutils.amnet.com.au/ClientLogoff.aspx',
		],

		varsDisplay: {
			'2,0': {
				'NONE': '{2:4|startdate} {2:1|planname}',
				'COLUMNHEADING': ['Basic', 'Peering'],
				'Download': ['{2:5|GB|download} / {2:2|GB|download-quota}', '{2:7|GB|downloadpo} / {2:3|GB|downloadpo-quota}'],
				'Upload': ['{2:6|GB|upload}', '{2:8|GB|uploadpo}'],
			}
		},
	
	},
	
	'wildit': {
		name: 'Wild I&T',
		description: 'Please enter your Usage Allowance!',

		prefs: {
			'download-quota': ['Download Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
		},

		process: [
			'POST https://members.wildit.net.au/area/login.pl action=login&user={USERNAME}&password={PASSWORD}',
			'REFRESHREDIRECT',
			[
				/Your Login is invalid please retry/, "ERROR",
				/action="([^"]+)"><input type="hidden" name="([^"]+)" value="([^"]+)"><input type="hidden" name="action" value="fullusage">/,
			],

			'USAGEPAGE',
			'POST https://members.wildit.net.au/area/{2:1} {2:2}={2:3}&action=fullusage',
			[ 
				/([0-9:]+)<\/td><td class="Cell2" align="right" colspan="1">([0-9,\.]+)<\/td><td class="Cell2" align="right" colspan="1">([0-9,\.]+)/,
			],
		],

		varsDisplay: {
			'1,0': {
				//'Online duration': '{1:1}',
				'Upload': '{1:3|MB|upload}',
				'Download': '{1:2|MB|download} / {download-quota}',
			}
		},

	},
		
	'netxp': {
		name: 'netXP',
		prefs: {
			'USERNAME': 'Username',
			'PASSWORD': null
		},

		process: [
			'POST http://netxp.com.au/internet/netusage.php dialuser={USERNAME}',
			[ 
				/([^,]+),([0-9\-]+),([0-9\-]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),0,0,([0-9\-]+)/,
				/([^,]+),([0-9\-]+),([0-9\-]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),([0-9\-]+)/,
				/([^\r\n]+)/, "ERROR",
			],
			'STARTUSAGEPAGE',
			'GET http://netxp.com.au/internet/?content=toolbox',
		],

		varsDisplay: {
			'0,0': {
				'NONE': '{0:2|startdate} {0:1|planname}',
				'Last Updated': '{0:7}',
				'Upload': '{0:6|MB|upload}',
				'Download': '{0:5|MB|download} / {0:4|MB|download-quota}',
			},
			'0,1': {
				'NONE': '{0:2|startdate} {0:1|planname}',
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Download': ['{0:5|MB|download} / {0:4|MB|download-quota}', '{0:8|MB|downloadpo} / {0:7|MB|downloadpo-quota}'],
				'Upload': ['{0:6|MB|upload}', ''],
				'Last Updated': '{0:9}',
			}
		},

	},
	
	'activ8me': {
		name: 'ACTIV8me',
		description: 'Please enter your Usage Allowance',
		prefs: {
			'usage-quota': ['Usage Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
		},
		process: [
			'GET https://secure.activ8me.net.au/login.aspx?ReturnUrl=%2fsecure%2fwelcome.aspx',
			/name="__VIEWSTATE"[\s]+value="([^"]+)/,
			'POST https://secure.activ8me.net.au/login.aspx?ReturnUrl=%2fsecure%2fwelcome.aspx __VIEWSTATE={0:1}&tbUsername={USERNAME}&tbPassword={PASSWORD}&Button1=Login',
			[ /Incorrect Username or Password/, "ERROR", /./ ],
			'USAGEPAGE',
			'GET https://secure.activ8me.net.au/secure/usagesummary.aspx',
			/<td>Total Usage<\/td><td>&nbsp;<\/td><td align="Right">([0-9\.]+) Mb<\/td><td align="Right">([0-9\.]+) Mb<\/td><td align="Right">([0-9\.]+) Mb/,
			'GET https://secure.activ8me.net.au/logout.aspx',
		],
		varsDisplay: {
			'2,0': {
				'Usage': '{2:3|MB|usage} / {usage-quota}',
				'Download': '{2:1|download}',
				'Upload': '{2:2|upload}',
			},
		},
	},

	'aapt': {
		name: 'AAPT',
		description: 'Please enter your Download Allowance',
		vars: {
			'basicrealm': 'Customer Information',
		},
		prefs: {
			'download-quota': ['Download Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
		},
		process: [
			'GETBASIC https://dialup.connect.com.au/cgi-bin/subscribers/index.cgi',
			/\?tuser=([^" &]+)/,
			'GETBASIC https://dialup.connect.com.au/cgi-bin/subscribers/usagepd.cgi?tuser={0:1}',
			'USAGEPAGE',
			'POSTBASIC https://dialup.connect.com.au/cgi-bin/subscribers/usagepd.cgi?tuser={0:1} c_type=0%2C1%2C2%2C3%2C4%2C5%2C6&start_date=01&start_month={now_month}&start_year={now_year}&end_date={now_day}&end_month={now_month}&end_year={now_year}&action=Show+Connections&tuser={0:1}',
			/Overall Totals[^`]+?([0-9\.]+) MB[^`]+?([0-9\.:]+)<\/TD>/,
		],
		varsDisplay: {
			'1,0': {
				'Usage': '{1:1|MB|download} / {download-quota}',
				'Time': '{1:2}',
			},
		},
	},
	
	'winshop': {
		name: 'Winshop',
		prefs: {
			'PASSWORD': null,
		},
		process: [
			'GET https://custinfo.winshop.com.au/usage/?username={USERNAME}',
			/<td>([^<]+)<\/td>[\s]+<td>([0-9\.]+)<\/td>[\s]+<td>MBYTES OUT<\/td>[\s]+<td>([0-9\.]+)<\/td>[\s]+<td>([0-9\.]+)<\/td>[\s]+<td>[^<]+<\/td>[\s]+<td>([0-9\-]+)/,
		],
		varsDisplay: {
			'0,0': {
				'NONE': '{0:5|startdate}',
				'Download': '{0:3|MB|download} / {0:2|MB|download-quota}',
				'Upload': '{0:4|MB|upload}',
				'Status': '{0:1}',
			},
		},
	},
	
	'letsgo': {
		name: 'Lets Go',
		description: 'Please enter your Download Allowance',
		prefs: {
			'download-quota': ['Download Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
		},
		process: [
			'POST https://secure.letsgo.com.au/memberslounge/memhome.php Feature=Login&UserName={USERNAME}&Password={PASSWORD}&view=&display=&Section=&Area1=',
			[ /To log into your account simply enter your username and password/, "ERROR", /./, ],
			'USAGEPAGE',
			'POST https://secure.letsgo.com.au/memberslounge/usage_meter.php?ServiceType=Internet MonthDay=month&UnitsFloor=0&NoOfUnits=30&ShowDetails=1',
			/<td class=tabcont>[\s]*([0-9\.]+) MB[\s]*<\/td>[\s]*<td class=tabcont>[\s]*([0-9\.]+) MB[\s]*<\/td>[\s]*/,
			'GET https://secure.letsgo.com.au/memberslounge/memhome.php?Feature=Logout',
		],
		varsDisplay: {
			'1,0': {
				'COLUMNHEADING': ['Download', 'Upload'],
				'Download': ['{1:1|MB|download} / {download-quota}', '{1:2|MB|upload|usagepo} / {download-quota|usagepo-quota}'],
			},
		},
	},
	
	'bordernet': {
		name: 'BorderNET',
		process: [
			'GET https://secure.bordernet.com.au/borderlogin.php',
			'POST https://secure.bordernet.com.au/login_script.php account=&username={USERNAME}&password={PASSWORD}&Submit=Login',
			[ /Incorrect login;  Please try again/, "ERROR", /./ ],
			'GET https://secure.bordernet.com.au/services.php',
			/adsl_viewusage\.php\?serviceid=([0-9]+)&accountno=([0-9]+)&account=([0-9A-Za-z]+)/,
			'GET https://secure.bordernet.com.au/adsl_viewusage.php?serviceid={1:1}&accountno={1:2}&account={1:3}',
			/name="stype">[\s]+<option [A-Za-z]* value="([^"]+)/,
			'USAGEPAGE',
			'POST https://secure.bordernet.com.au/adsl_viewusage.php serviceid={1:1}&accountno={1:2}&account={1:3}&day1=1&month1={now_month_3l}&year1={now_year}&day2=31&month2=&year2=&stype={2:1}&submit1=Get+Usage',
			/Used[\s]+<\/td>[\s]+<td>[\s]+[^<]+<\/td>[\s]+<td>[\s]+([0-9\.]+)[\s]+<\/td>[\s]+<td>[\s]+([0-9\.]+)[^`]+?Allowed[\s]+<\/td>[\s]+<td>[\s]+[^<]+<\/td>[\s]+<td>[\s]+([0-9\.]+)/,
			'GET https://secure.bordernet.com.au/logout.php',
		],
		varsDisplay: {
			'3,0': {
				'Download': '{3:1|MB|download} / {3:3|MB|download-quota}',
				'Upload': '{3:2|MB|upload}',
			},
		},
		
	},
	
	'koalatelecom': {
		name: 'Koala Telecom',
		prefs: {
			'download-quota': ['Download Allowance (MB) (Obsolete, please [leave] empty ->)', PREF_TYPE_INT]
		},
		process: [
			'POST https://members.koalatelecom.com.au/user/login?destination=node%2F228 edit%5Bname%5D={USERNAME}&edit%5Bpass%5D={PASSWORD}&op=Log+in',
			[/Sorry\. Unrecognized username or password/, "ERROR", /./],
			'GET https://members.koalatelecom.com.au/broadband/custusage',
			/edit-dsl_id"><option value="([^"]+)[^`]+?edit\[token\]" value="([^"]+)/,
			'USAGEPAGE',
			'POST https://members.koalatelecom.com.au/broadband/custusage edit%5Bdsl_id%5D={1:1}&op=Select&edit%5Btoken%5D={1:2}',
			/Monthly Limit<\/td><td><b>([0-9\.]+)MB[^`]+?Shaping Status<\/td><td><b>([^<]+)[^`]+?PIPE<\/td><td>([0-9\.]+)MB[^`]+?Whirlpool<\/td><td>([0-9\.]+)MB[^`]+?Koala Usenet News<\/td><td>([0-9\.]+)MB[^`]+?Metered Usage<\/td><td><b>([0-9\.]+)MB/,
			'GET https://members.koalatelecom.com.au/logout',
		],
		varsDisplay: {
			'2,0': {
				'Download': '{2:6|MB|download} / {2:1|download-quota}',
				'Usenet': '{2:5|MB|free-usenet}',
				'PIPE': '{2:3|MB|free-pipe}',
				'Whirlpool': '{2:4|MB|free-wpool}',
				'Shaping': '{2:2}',
			},
		},
	},
	'iprimus': {
		name: 'iPrimus',
		process: [
			function (vars) {
				vars['tzoffset'] = (new Date()).getTimezoneOffset();
			},
			'GET https://toolbox.iprimus.com.au/FormsLogin.asp',
			'USAGEPAGE',
			'POST https://toolbox.iprimus.com.au/verifpwd.asp Username={USERNAME}&password={PASSWORD}&submit=Login&URL=%2FUsageOverall.asp&timezoneoffset={tzoffset}',
			[ 
				/Period from [A-Za-z]+, ([0-9 ]+ [A-Za-z]+ [0-9]+) to [A-Za-z]+, ([0-9 ]+ [A-Za-z]+ [0-9]+)<\/b><\/span>[\s]+<br><b> Plan name : <\/b> ([^\/]+\/([0-9]+)MB)[\s]+<table bgcolor="#FFFFFF" border="0" cellpadding="2" cellspacing="2" width="100%"><tr><td class="clsTableHead"><b>Username<\/b><\/td><td class="clsTableHead"><b>Total Time<\/b><\/td><td class="clsTableHead"><b>Total Uploads<\/b><\/td><td class="clsTableHead"><b>Total Downloads<\/b><\/td><td class="clsTableHead"><b>Last Recorded Session<\/b><\/td><td class="clsTableHead">&nbsp;<\/td><\/tr>[\s]+<form action="usagedetail.asp" method=get id=form1 name=form1><tr><td class="clsTableBody">[^<]+<\/td><td class="clsTableBody">([0-9]+)h&nbsp;([0-9]+)m&nbsp;<\/td><td class="clsTableBody">([0-9\.]+) MB<\/td><td class="clsTableBody">([0-9\.]+) MB<\/td><td class="clsTableBody">([^<]+)<\/td><td class="clsTableBody"><input type=hidden name=thismember value="[^"]+"><input type=hidden name=startdate value="[^"]+"><input type=hidden name=enddate value="[^"]+"><input type="hidden" name="PlanName" value="[^"]+"><input type=submit value="Details\.\.\." id=submit1 name=submit1><\/td><\/tr><\/form>[\s]+<\/table><br><br>[\s]+<span class="clsNormal"><B>Note:/,
				/Log in using your username and password/, "ERROR",
			]
		],
		varsDisplay: {
			'0,0': {
				'NONE': '{0:1|startdate} {0:2|enddate} {0:3|planname}',
				'Download': '{0:8|MB|download} / {0:4|MB|download-quota}',
				'Upload': '{0:7|MB|upload}',
				'Duration': '{0:5}h {0:6}m',
			}
		},
	},
	
	'eftel': {
		name: 'EFTel',
		prefs: {
			'USERNAME': 'Email',
			'usage-quota': ['Limit for unlimited plans (MB)', PREF_TYPE_INT]
		},
		process: [
			'GET https://myaccount.eftel.com/MyAccount/Security/SignOn.aspx?ReturnUrl=%2FMyAccount%2Fmenu%2Easp',
			/__VIEWSTATE" value="([^"]+)/,
			'POST https://myaccount.eftel.com/MyAccount/Security/SignOn.aspx?ReturnUrl=%2fMyAccount%2fmenu.asp __EVENTTARGET=&__EVENTARGUMENT=&__VIEWSTATE={0:1}&IdentifierTextBox={USERNAME}&PasswordTextBox={PASSWORD}&SignOnButton=Sign+on',
			[
				/Plan type<\/td>[\s]+<td>([^<]+)[^`]+?Billing period<\/td>[\s]+<td>[A-Za-z]{3} ([0-9\-A-Za-z]+) to [A-Za-z]{3} ([0-9\-A-Za-z]+)/,
				/Your email address and\/or password has been entered incorrectly/, "ERROR",
			],
			'USAGEPAGE',
			'GET https://myaccount.eftel.com/MyAccount/inquiry/view_sessions.asp',
			[
				/Traffic<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)[^`]+?Traffic off peak<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)[^`]+?Freezone<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)[^`]+?You are permitted ([0-9,\.]+) MB of <i>peak[^`]+?You are permitted ([0-9,\.]+) MB of <i>offpeak/,
				/Traffic<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)<\/td>[\s]+<td align="right">([0-9,\.]+)/,
			],
			/* 'MAPVARS',
			function (vars) {
				// TODO don't think we need this
				// within-quota + excess
				if (vars['parse2'] == 0) {
					vars['upload'] += parseInt(vars['2:3'], 10);
					vars['download'] += parseInt(vars['2:4'], 10);
					vars['uploadpo'] += parseInt(vars['2:7'], 10);
					vars['downloadpo'] += parseInt(vars['2:8'], 10);
				}
			}, */
		],
		varsDisplay: {
			'1,0': {
				'NONE': '{1:1|planname} {1:2|startdate} {1:3|enddate}',
			},
			'2,0': {
				'COLUMNHEADING': ['Peak', 'Off-peak'],
				'Upload': ['{2:1|MB|upload}', '{2:5|MB|uploadpo}'],
				'Download': ['{2:2|MB|download} / {2:11|MB|download-quota}', '{2:6|MB|downloadpo} / {2:12|MB|downloadpo-quota}'],
				'Free': '{2:9|MB|free-upload} up {2:10|MB|free-download} down',
			},
			'2,1': {
				'Usage': '{2:5|MB|usage} / {usage-quota}',
				'Upload': '{2:1|MB|upload}',
				'Download': '{2:2|MB|download}',
			},
		},
	},

}
